-- Test add_campsite_feature
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(12);

set search_path to camper, public;

select has_function('camper', 'add_campsite_feature', array['integer', 'text', 'text', 'text']);
select function_lang_is('camper', 'add_campsite_feature', array['integer', 'text', 'text', 'text'], 'sql');
select function_returns('camper', 'add_campsite_feature', array['integer', 'text', 'text', 'text'], 'integer');
select isnt_definer('camper', 'add_campsite_feature', array['integer', 'text', 'text', 'text']);
select volatility_is('camper', 'add_campsite_feature', array['integer', 'text', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'add_campsite_feature', array ['integer', 'text', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'add_campsite_feature', array ['integer', 'text', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'add_campsite_feature', array ['integer', 'text', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'add_campsite_feature', array ['integer', 'text', 'text', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_feature cascade;
truncate campsite cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
     , (2, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (3, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into campsite_type (campsite_type_id, company_id, media_id, name, description, active, max_campers, bookable_nights)
values (4, 1, 3, 'Type A', '<p>A</p>', true, 4, '[1, 7]')
     , (5, 1, 3, 'Type B', '<p>B</p>', true, 5, '[2, 5]')
;

insert into campsite (campsite_id, company_id, label, campsite_type_id)
values (6, 1, 'A1', 4)
     , (7, 2, 'A1', 5)
;

select lives_ok(
	$$ select add_campsite_feature(1, 'A1', 'wifi', 'Feature 1') $$,
	'Should be able to add an feature to the first campsite'
);

select lives_ok(
	$$ select add_campsite_feature(2, 'A1', 'information', 'Feature 2') $$,
	'Should be able to add an feature to the second campsite'
);

select bag_eq(
	$$ select campsite_id, icon_name, name from campsite_feature $$,
	$$ values (6, 'wifi', 'Feature 1')
	        , (7, 'information', 'Feature 2')
	$$,
	'Should have added all two campsite features'
);

select *
from finish();

rollback;
